with Ada.Text_IO;

package body Cards is
    
    procedure Init is
    begin
        Reset(Gen);
    end Init;

    function Get_Three_Random_Cards return Cards_Array_Type is
        Cards: Cards_Array_Type := (others => To_Card(0));
        Current: Card_Index_Type;
        Is_Fresh: Boolean;
    begin
        for J in Integer range 1 .. 3 loop
            loop
                Current := Random(Gen);
                Is_Fresh := True;

                for K in Integer range 1 .. J-1 loop
                    if To_Card(Current) = Cards(K) then
                        Is_Fresh := False;
                        exit;
                    end if;
                end loop;

                exit when Is_Fresh;
            end loop;

            Cards(J) := To_Card(Current);
        end loop;

        return Cards;
    end Get_Three_Random_Cards;

    function To_Card(Index: Card_Index_Type) return Card_Type is
        Value: constant Value_Type := Value_Type'Val(Index / 4);
        Suit:  constant Suit_Type  := Suit_Type'Val(Index mod 4);
    begin
        return Card_Type'(Value => Value, Suit => Suit);
    end To_Card;

    procedure Put(Card: Card_Type) is
        use Ada.Text_IO;
        package Suit_Type_IO is new Ada.Text_IO.Enumeration_IO(Suit_Type);
        use Suit_Type_IO;
        package Value_Type_IO is new Ada.Text_IO.Enumeration_IO(Value_Type);
        use Value_Type_IO;
    begin
        Put("Suit: ");
        Put(Card.Suit);

        Put(", Value: ");
        Put(Card.Value);
        New_Line;
    end Put;

end Cards;