with Ada.Numerics.Discrete_Random;

package Cards is
    
    type Suit_Type is  (Clubs, Diamonds, Hearts, Spades);
    type Value_Type is (Two, Three, Four, Five, Six, Seven, Eight, Nine, Ten, 
        Jack, Queen, King, Ace);
    subtype Card_Index_Type is Natural range 0 .. 51;

    type Card_Type is record
        Suit: Suit_Type;
        Value: Value_Type;
    end record;
    type Cards_Array_Type is array (1..3) of Card_Type;

    procedure Init;
    function Get_Three_Random_Cards return Cards_Array_Type;
    function To_Card(Index: Card_Index_Type) return Card_Type;
    procedure Put(Card: Card_Type);

private 
    
    package Random_Card is new Ada.Numerics.Discrete_Random(Card_Index_Type);
    use Random_Card;

    Gen: Random_Card.Generator;  -- A random-value generator

end Cards;