with Ada.Integer_Text_IO;
with Ada.Text_IO;

package body Bank_Accounts is
    
    function Get_Balance(Account: in Account_Type) return Cents_Type is
    begin
        return Account.Balance;
    end Get_Balance;
    
    -- -----------------------------------------------------

    procedure Deposit(Account: in out Account_Type; Amount: in Cents_Type) is
    begin
        Account.Balance := Account.Balance + Amount;
    end Deposit;
    
    -- -----------------------------------------------------
    
    procedure Withdraw(Account: in out Account_Type; Amount: in Cents_Type) is
    begin
        Account.Balance := Account.Balance - Amount;
    end Withdraw;

    -- -----------------------------------------------------
    
    procedure Transfer(From: in out Account_Type; 
                       To: in out Account_Type; 
                       Amount: in Cents_Type) is
    begin
        From.Balance := From.Balance - Amount;
        To.Balance   := To.Balance + Amount;
    end Transfer;

    -- -----------------------------------------------------
    
    procedure Put(Account: in Account_Type) is
        Major_Currency: constant Natural := Account.Balance / 100;
        Minor_Currency: constant Natural := Account.Balance mod 100;
    begin
        Ada.Integer_Text_IO.Put(Item => Major_Currency, Width => 10);
        Ada.Text_IO.Put(".");
        Ada.Integer_Text_IO.Put(Item => Minor_Currency, Width => 2);
        Ada.Text_IO.New_Line;
    end Put;

end Bank_Accounts;

